class: Workflow
cwlVersion: v1.0
id: prep
label: prep
$namespaces:
  sbg: 'https://www.sevenbridges.com/'
inputs:
  - id: msin
    type: 'Directory[]'
    'sbg:x': -1000
    'sbg:y': -900
  - id: filter_baselines
    type: string
    'sbg:x': -1000
    'sbg:y': -800
  - id: raw_data
    type: boolean
    'sbg:x': -1000
    'sbg:y': -700
  - id: demix
    type: boolean
    'sbg:x': -1000
    'sbg:y': -600
  - id: max_dppp_threads
    type: int?
    default: 10
    'sbg:x': -1000
    'sbg:y': -500
  - id: memoryperc
    type: int
    'sbg:x': -1000
    'sbg:y': -400
  - id: flag_baselines
    type: 'string[]'
    'sbg:x': -1000
    'sbg:y': -300
  - id: avg_timeresolution
    type: float
    'sbg:x': -1000
    'sbg:y': -200
  - id: avg_freqresolution
    type: string
    'sbg:x': -1000
    'sbg:y': -100
  - id: process_baselines_cal
    type: string
    'sbg:x': -1000
    'sbg:y': 0
  - id: demix_timestep
    type: int
    'sbg:x': -1000
    'sbg:y': 100
  - id: demix_freqstep
    type: int
    'sbg:x': -1000
    'sbg:y': 200
  - id: demix_target
    type: string
    'sbg:x': -1000
    'sbg:y': 300
  - id: demix_sources
    type: 'string[]'
    'sbg:x': -1000
    'sbg:y': 400
  - id: do_smooth
    type: boolean
    'sbg:x': -1000
    'sbg:y': 500
  - id: min_length
    type: int?
    'sbg:x': -1000
    'sbg:y': 600
  - id: overhead
    type: float?
    'sbg:x': -1000
    'sbg:y': 700
  - id: min_separation
    type: int?
    'sbg:x': -1000
    'sbg:y': 800
  - id: max_separation_arcmin
    type: float?
    'sbg:x': -1000
    'sbg:y': 900
  - id: calibrator_path_skymodel
    type: Directory?
    'sbg:x': -1000
    'sbg:y': 1000
  - id: A-Team_skymodel
    type: File?
    'sbg:x': -1000
    'sbg:y': 1100
  - id: elevation
    type: string
    default: 0deg..20deg
    'sbg:x': -1000
    'sbg:y': 1200
  - id: amplmin
    type: float
    default: 1.e-30
    'sbg:x': -1000
    'sbg:y': 1300
outputs:
  - id: check_Ateam_separation.png
    outputSource:
      - check_ateam_separation/output_imag
    type: 'File[]?'
    'sbg:x': 1000
    'sbg:y': -300
  - id: check_Ateam_separation.log
    outputSource:
      - check_ateam_separation/logfile
    type: 'File[]?'
    'sbg:x': 1000
    'sbg:y': -200
  - id: make_sourcedb_ateam.log
    outputSource:
      - make_sourcedb/log
    type: File?
    'sbg:x': 1000
    'sbg:y': -100
  - id: msout
    outputSource:
      - ndppp_prep_cal/msout
    type: 'Directory[]'
    'sbg:x': 1000
    'sbg:y': 0
  - id: logfile_prep_cal
    outputSource:
      - ndppp_prep_cal/logfile
    type: 'File[]?'
    'sbg:x': 1000
    'sbg:y': 100
  - id: parset
    outputSource:
      - ndppp_prep_cal/parset
    type: 'File[]'
    'sbg:x': 1000
    'sbg:y': 200
  - id: find_skymodel_cal.log
    outputSource:
      - find_skymodel_cal/logfile
    type: 'File[]?'
    'sbg:x': 1000
    'sbg:y': 300
steps:
  - id: ndppp_prep_cal
    in:
      - id: baselines_to_flag
        default: []
        source:
          - flag_baselines
      - id: elevation_to_flag
        source: elevation
      - id: min_amplitude_to_flag
        source: amplmin
      - id: memoryperc
        default: 20
        source: memoryperc
      - id: raw_data
        default: false
        source: raw_data
      - id: demix
        default: false
        source: demix
      - id: msin
        linkMerge: merge_flattened
        source:
          - msin
      - id: msin_baseline
        default: '*'
        source: filter_baselines
      - id: skymodel
        source: make_sourcedb/sourcedb
      - id: timeresolution
        default: 1
        source: avg_timeresolution
      - id: freqresolution
        default: 12.21kHz
        source: avg_freqresolution
      - id: demix_timestep
        default: 1
        source: demix_timestep
      - id: demix_freqstep
        default: 1
        source: demix_freqstep
      - id: demix_baseline
        default: '*'
        source: process_baselines_cal
      - id: target_source
        source: demix_target
      - id: ntimechunk
        default: 10
        source: max_dppp_threads
      - id: subtract_sources
        source:
          - demix_sources
    out:
      - id: msout
      - id: logfile
      - id: parset
    run: ../../subworkflow/ndppp_prep_cal.cwl
    label: ndppp_prep_cal
    scatter:
      - msin
    'sbg:x': 0
    'sbg:y': 0
  - id: check_ateam_separation
    in:
      - id: ms
        source:
          - msin
      - id: min_separation
        source: min_separation
    out:
      - id: output_imag
      - id: logfile
    run: ../../lofar-cwl/steps/check_ateam_separation.cwl
    label: check_Ateam_separation
    'sbg:x': 0
    'sbg:y': -300
  - id: make_sourcedb
    in:
      - id: sky_model
        source: A-Team_skymodel
    out:
      - id: sourcedb
      - id: log
    run: ../../lofar-cwl/steps/makesourcedb.cwl
    label: make_sourcedb_ateam
    'sbg:x': -500
    'sbg:y': 300
  - id: find_skymodel_cal
    in:
      - id: msin
        source:
          - msin
      - id: skymodels
        source: calibrator_path_skymodel
      - id: max_separation_arcmin
        source: max_separation_arcmin
    out:
      - id: output_models
      - id: model_name
      - id: logfile
    run: ../../steps/find_skymodel_cal.cwl
    label: find_skymodel_cal
    'sbg:x': -500
    'sbg:y': 500
  - id: BLsmooth
    in:
      - id: msin
        linkMerge: merge_flattened
        source:
          - ndppp_prep_cal/msout
      - id: do_smooth
        source: do_smooth
    out:
      - id: msout
    run: ../../steps/blsmooth.cwl
    label: BLsmooth
    scatter:
      - msin
    'sbg:x': 300
    'sbg:y': 0
requirements:
  - class: SubworkflowFeatureRequirement
  - class: ScatterFeatureRequirement
